package cn.cecep.talroad.controller;

import cn.cecep.talroad.common.core.exception.CommonException;
import cn.cecep.talroad.common.core.utils.poi.ExcelUtil;
import cn.cecep.talroad.common.core.web.controller.BasesController;
import cn.cecep.talroad.common.core.web.domain.AjaxResults;
import cn.cecep.talroad.common.log.annotation.Log;
import cn.cecep.talroad.common.log.enums.BusinessType;
import cn.cecep.talroad.common.security.annotation.RequiresPermissions;
import cn.cecep.talroad.domain.BMainPollDis;
import cn.cecep.talroad.service.IBMainPollDisService;
import cn.cecep.talroad.util.ConvertNumber;
import cn.cecep.talroad.vo.BMainPollDisVo;
import cn.cecep.talroad.vo.query.BMainPollDisQuery;
import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.util.ObjectUtil;
import cn.hutool.core.util.StrUtil;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.CollectionUtils;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletResponse;
import java.security.InvalidParameterException;
import java.util.Arrays;
import java.util.List;


/**
 * * 开发公司：中节能天融科技有限公司
 * 排污许可Controller 控制层
 *
 * @author szhpt
 * @date 2023-01-18*/
@Api(tags = "排污许可--排污许可")
@RestController
@RequestMapping("/BMainPollDis")
public class BMainPollDisController extends BasesController
{
    @Autowired
    private IBMainPollDisService bMainPollDisService;

    /**
     * 查询排污许可列表
     */
    @ApiOperation(value = "查询排污许可")
    @GetMapping("/list")
    public AjaxResults<IPage<BMainPollDis>> list(BMainPollDisQuery bMainPollDis)
    {
        Page<BMainPollDis> page = new Page<>(bMainPollDis.getPageNum(), bMainPollDis.getPageSize());
        IPage<BMainPollDis> list = bMainPollDisService.page(page, BMainPollDisQuery.createLambdaQueryWrapper(bMainPollDis));
        if(!CollectionUtils.isEmpty(list.getRecords())){
            list.getRecords().forEach(item->{
                item.setBusinessType(BMainPollDis.PwxkzType.getByCode(item.getBusinessType()).desc);
                item.setEditionCode(ConvertNumber.chineseNumToArabicNum(item.getEditionCode().replaceAll("第","").replaceAll("版","")).toString());
            });
        }
        return AjaxResults.success(list);
    }
    

    /**
     * 导出排污许可列表
     */
    @ApiOperation(value = "导出排污许可")
    @Log(title = "排污许可", businessType = BusinessType.EXPORT)
    @PostMapping("/export")
    public void export(HttpServletResponse response, BMainPollDis bMainPollDis)
    {
        List<BMainPollDis> list = bMainPollDisService.selectBMainPollDisList(bMainPollDis);
        ExcelUtil<BMainPollDis> util = new ExcelUtil<BMainPollDis>(BMainPollDis.class);
        util.exportExcel(response, list, "排污许可数据");
    }

    /**
     * 获取排污许可详细信息
     */
    @ApiOperation(value = "获取排污许可详细信息")
    @PostMapping(value = "/{id}")
    public AjaxResults<BMainPollDis> getInfo(@PathVariable("id") String id) {
        return AjaxResults.success(bMainPollDisService.getById(id));
    }
    /**
     * 新增排污许可
     */
    @ApiOperation(value = "新增排污许可")
    @Log(title = "排污许可", businessType = BusinessType.INSERT)
    @PostMapping(value = "/add")
    public AjaxResults<Boolean> add(@RequestBody BMainPollDis bMainPollDis) {
        return toAjax(bMainPollDisService.save(bMainPollDis));
    }
    /**
     * 修改排污许可
     */
    @ApiOperation(value = "修改排污许可")
    @Log(title = "排污许可", businessType = BusinessType.UPDATE)
    @PostMapping(value = "/edit")
    public AjaxResults<Boolean> edit(@RequestBody BMainPollDisVo bMainPollDisVo) {
        if(ObjectUtil.isEmpty(bMainPollDisVo)){
            throw new InvalidParameterException("参数为空");
        }
        if(ObjectUtil.isEmpty(bMainPollDisVo.getId())){
            throw new InvalidParameterException("参数id为空");
        }
        BMainPollDis bMainPollDis = bMainPollDisService.getById(bMainPollDisVo.getId());
        if(ObjectUtil.isEmpty(bMainPollDis)){
            throw new CommonException(StrUtil.format("根据id{}查询不到数据", bMainPollDisVo.getId()));
        }
        //赋值
        BeanUtil.copyProperties(bMainPollDisVo,bMainPollDis);
        return toAjax(bMainPollDisService.saveOrUpdate(bMainPollDis));
    }

    /**
     * 删除排污许可
     */
    @ApiOperation(value = "删除排污许可")
    @RequiresPermissions("talroad:BMainPollDis:remove")
    @Log(title = "排污许可", businessType = BusinessType.DELETE)
    @PostMapping("/{ids}")
    public AjaxResults<Boolean> remove(@PathVariable String[] ids) {
        return toAjax(bMainPollDisService.removeByIds(Arrays.asList(ids)));
    }
}
